package option_either.generator.definition;

/**
 * Option fr die Methode,
 * in welcher die zu
 * implementierenden Methoden
 * fr die jeweilige Variante
 * aufgerufen werden.
 * 
 * @author Heiner K&uuml;cker
 */
public enum SwitchExecutionMethod
{
    /**
     * Der Switch mit den zu
     * implementierenden Methoden
     * fr die jeweilige Variante
     * soll im Konstruktor
     * aufgerufen werden.
     * <br/>
     * Vorteil:
     * Der Aufruf der execute-Methode
     * kann nicht aus Versehen
     * vergessen werden.
     * <br/>
     * Nachteil:
     * Es ist nicht mglich, in
     * Konstruktoren von
     * Klassen, welche von der
     * inneren Either-Klasse 
     * ableiten, Code vor dem 
     * Switch auszufhren.
     */
    CONSTRUCTOR ,

    /**
     * Der Switch mit den zu
     * implementierenden Methoden
     * fr die jeweilige Variante
     * soll in einer speziell
     * dafr zu generierenden
     * execute-Methode
     * aufgerufen werden.
     * <br/>
     * Vorteil:
     * Es ist mglich, in
     * Konstruktoren von
     * Klassen, welche von der
     * inneren Either-Klasse 
     * ableiten, Code vor dem 
     * Switch auszufhren.
     * 
     * Damit nicht eventuell
     * der Aufruf der execute-
     * Methode vergessen wird,
     * empfehle ich, diese im
     * abgeleiteten Konstruktor
     * aufzurufen.
     * 
     * Hierbei muss unterschieden
     * werden, ob der Return-Wert
     * der execute-Methode benutzt
     * oder verworfen werdn soll.
     * <br/>
     * Nachteil:
     * Der Aufruf der execute-Methode
     * kann aus Versehen
     * vergessen werden.
     */
    EXECUTE_METHOD ;
}
