package option_either.generator.definition.clazz;

/**
 * Abstrakte Oberklasse alle Type-Variable
 * der {@link ClassWithTypeParams}.
 * <br/>
 * Type-Variable besitzen einen Namen
 * und keine konkrete Klasse/Type.
 * <br/>
 * Typ-Parameter mit einem Namen, nicht gebunden.
 * 
 * @author Heiner K&uuml;cker
 */
public class AbstractTypeVariable
extends AbstractTypeParameter
{
    /**
     * Kommentar/Erluterung der Typ-Variable
     */
    public final String description;

    /**
     * Name der Typ-Variable
     */
    public final String name;

    /**
     * Konstruktor.
     * 
     * @param description Kommentar/Erluterung der Typ-Variable
     * @param name Name der Typ-Variable
     */
    protected AbstractTypeVariable(
            final String description ,
            final String name )
    {
        this.description = description;
        this.name = name;
    }

    /**
     * @see java.lang.Object#toString()
     */
    @Override
    public String toString()
    {
        throw new UnsupportedOperationException();
    }

    /**
     * Hilfs-Methode fr Generierung Javadoc
     * @return Javadoc-String
     */
    public final String toJavadocStr()
    {
        return "@param <" + this.name + "> " + this.description;
    }

}
