package option_either.generator.definition.clazz;


/**
 * Einfacher Type-Parameter ohne Namen, Typ-Argument, gebunden.
 * 
 * <pre>
 * &lt;String&gt;
 * <pre>
 * 
 * @author Heiner K&uuml;cker
 */
public final class BoundedTypeArgument
extends AbstractTypeArgument
{
    /**
     * gebundene Klasse.
     */
    public final ClassWithTypeParams boundClass;

    /**
     * Konstruktor.
     * 
     * @param boundClass gebundene Klasse
     */
    public BoundedTypeArgument(
            final ClassWithTypeParams boundClass )
    {
        this.boundClass = boundClass;
    }

    /**
     * @see java.lang.Object#toString()
     */
    @Override
    public String toString()
    {
        return this.boundClass.toString();
    }

}
