package option_either.generator.definition.clazz;

/**
 * Typ-Argument extends-Wildcard.
 * 
 * <pre>
 * &lt;? extends MyClass&gt;
 * <pre>
 * 
 * @author Heiner K&uuml;cker
 */
public final class ExtendsTypeArgument
extends AbstractTypeArgument
{
    /**
     * gebundene Klasse.
     */
    public final ClassWithTypeParams boundClass;

    /**
     * Konstruktor.
     * 
     * @param boundClass gebundene Klasse
     */
    public ExtendsTypeArgument(
            final ClassWithTypeParams boundClass )
    {
        this.boundClass = boundClass;
    }

    /**
     * @see java.lang.Object#toString()
     */
    @Override
    public String toString()
    {
        return "? extends " + this.boundClass;
    }

}
