package option_either.generator.definition.clazz;

/**
 * Typ-Variable, nicht gebunden, mit einem extends-Constraint.
 * 
 * <pre>
 * &lt;? extends MyName&gt;
 * <pre>
 * 
 * @author Heiner K&uuml;cker
 */
public final class ExtendsTypeVariable
extends AbstractTypeVariable
{
    /**
     * Nur Sub-Klassen einschiesslich selbst dieser Klasse/Type erlaubt
     */
    public final ClassWithTypeParams lowerBoundClass;

    /**
     * Konstruktor.
     * 
     * @param description Kommentar/Erluterung der Typ-Variable
     * @param name Name
     * @param lowerBoundClass Constraint-Klasse
     */
    public ExtendsTypeVariable(
            final String description ,
            final String name ,
            final ClassWithTypeParams lowerBoundClass )
    {
        super(
                description ,
                name );
        this.lowerBoundClass = lowerBoundClass;
    }

    /**
     * @see java.lang.Object#toString()
     */
    @Override
    public String toString()
    {
        return this.name + " extends " + this.lowerBoundClass;
    }

}
