package option_either.generator.definition.clazz;

/**
 * Typ-Argument super-Wildcard.
 * 
 * <pre>
 * &lt;? super MyClass&gt;
 * <pre>
 * 
 * @author Heiner K&uuml;cker
 */
public final class SuperTypeArgument
extends AbstractTypeArgument
{
    /**
     * gebundene Klasse.
     */
    public final ClassWithTypeParams boundClass;

    /**
     * Konstruktor.
     * 
     * @param boundClass gebundene Klasse
     */
    public SuperTypeArgument(
            final ClassWithTypeParams boundClass )
    {
        this.boundClass = boundClass;
    }

    /**
     * @see java.lang.Object#toString()
     */
    @Override
    public String toString()
    {
        return "? super " + this.boundClass;
    }

}
