package option_either.generator.definition.clazz;

/**
 * Typ-Variable, nicht gebunden, mit einem super-Constraint.
 * 
 * <pre>
 * &lt;? super MyName&gt;
 * <pre>
 * 
 * @author Heiner K&uuml;cker
 */
public final class SuperTypeVariable
extends AbstractTypeVariable
{
    /**
     * Nur Super-Klassen einschiesslich selbst dieser Klasse/Type erlaubt
     */
    public final ClassWithTypeParams upperBoundClass;

    /**
     * Konstruktor.
     * 
     * @param description Kommentar/Erluterung der Typ-Variable
     * @param name Name
     * @param upperBoundClass Constraint-Klasse
     */
    public SuperTypeVariable(
            final String description ,
            final String name ,
            final ClassWithTypeParams upperBoundClass )
    {
        super(
                description ,
                name );
        this.upperBoundClass = upperBoundClass;
    }

    /**
     * @see java.lang.Object#toString()
     */
    @Override
    public String toString()
    {
        return this.name + " super " + this.upperBoundClass;
    }

}
